diff a/test/hotspot/jtreg/runtime/cds/appcds/indy/IndyTestBase.java b/test/hotspot/jtreg/runtime/cds/appcds/indy/IndyTestBase.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/indy/IndyTestBase.java
@@ -0,0 +1,300 @@
+/*
+ * Copyright (c) 2023, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+import java.io.FileWriter;
+import java.nio.file.Path;
+import java.nio.file.Paths;
+import java.util.regex.Matcher;
+import java.util.regex.Pattern;
+
+import jdk.test.lib.cds.CDSOptions;
+import jdk.test.lib.cds.CDSTestUtils;
+import jdk.test.lib.helpers.ClassFileInstaller;
+import jdk.test.lib.process.OutputAnalyzer;
+
+
+public class IndyTestBase {
+    static Pattern testOnlyPattern = null; // matches testNumber
+    static Pattern testSkipPattern = null; // matches testNumber    
+    static Pattern forceSkipPattern = null; // Force some tests to be disabled during development.
+    static int testNumber = 0;
+    static String appJar;
+    static OutputAnalyzer output = null; // after test() returns, this is the output of the final run
+    static OutputAnalyzer staticDumpOutput = null;
+    static String jtregTestCase = "testcase";
+
+    // bits for runMode
+    static final int RUN_STATIC = 1;   // Run with static archive only (no AOT)
+    static final int RUN_AOT    = 2;   // Run with AOT (which uses dynamic archive)
+    static final int RUN_BENCH  = 4;   // Run in benchmark mode (no logs)
+
+    static void setup(String appJar) throws Exception {
+      setup(null, appJar);
+    }
+
+    static void setup(String forceSkip, String appJar) throws Exception {
+        String testName = System.getProperty("test.name");
+        if (testName != null) {
+            Path p = Paths.get(testName);
+            String file = p.getFileName().toString();
+            int i = file.indexOf(".");
+            jtregTestCase = file.substring(0, i);
+        }
+        IndyTestBase.appJar = appJar;
+        String testOnly = System.getProperty(jtregTestCase + ".test.only");
+        if (testOnly != null) {
+            testOnlyPattern = Pattern.compile("^(" + testOnly + ")$");
+        }
+        String testSkip = System.getProperty(jtregTestCase + ".test.skip");
+        if (testSkip != null) {
+            testSkipPattern = Pattern.compile("^(" + testSkip + ")$");
+        }
+
+        if (forceSkip != null) {
+            forceSkipPattern = Pattern.compile("^(" + forceSkip + ")$");
+        }
+    }
+
+    static boolean shouldTest(String s) {
+        if (testOnlyPattern != null) {
+            Matcher matcher = testOnlyPattern.matcher(s);
+            if (!matcher.find()) {
+                return false;
+            }
+        }
+        if (testSkipPattern != null) {
+            Matcher matcher = testSkipPattern.matcher(s);
+            if (matcher.find()) {
+                return false;
+            }
+        }
+
+        return true;
+    }
+
+    // Run the test program with the same arg for both training run and production run
+    static void test(String testNote, String mainClass, String arg) throws Exception {
+        test(testNote, mainClass, arg, arg, RUN_STATIC);
+    }
+
+    static void test(String testNote, String mainClass, String trainingArg, String productionArg) throws Exception {
+        test(testNote, mainClass, trainingArg, productionArg, RUN_STATIC);
+    }
+
+    static void test(String testNote, String mainClass, String trainingArg, String productionArg, int runMode) throws Exception {
+        output = null;
+        testNumber ++;
+        String skipBy = null;
+
+        if (forceSkipPattern != null) {
+            Matcher matcher = forceSkipPattern.matcher(testNote);
+            if (matcher.find()) {
+                skipBy = " ***** (hard coded) Skipped by test note";
+            }
+        }
+        if (skipBy == null && !shouldTest("" + testNumber)) {
+            skipBy = " ***** Skipped by test number";
+        }
+
+        if (skipBy != null) {
+            System.out.println("         Test : #" + testNumber + ", " + testNote + skipBy);
+            return;
+        }
+
+        System.out.println("==================================================================");
+        System.out.println("         Test : #" + testNumber + ", " + testNote);
+        System.out.println("  trainingArg : " + trainingArg);
+        System.out.println("productionArg : " + productionArg);
+        System.out.println("      runMode : " + runModeString(runMode));
+        System.out.println("vvvv==========================================================vvvv");
+        String s = jtregTestCase + "-" + testNumber;
+        String classList = s + ".classlist";
+        String archiveName = s + ".jsa";
+
+        // Create classlist
+        System.out.println("#" + testNumber + ": Create classlist");
+        CDSTestUtils.dumpClassList(classList, "-cp", appJar, mainClass, trainingArg);
+
+        // Dump static archive
+        System.out.println("#" + testNumber + ": Dump static archive");
+        CDSOptions opts = (new CDSOptions())
+            .addPrefix("-XX:SharedClassListFile=" + classList,
+                       "-XX:+AOTClassLinking",  // by default enables AOTInvokeDynamicLinking
+                       "-XX:+ArchiveDynamicProxies",
+                       "-XX:+ArchiveReflectionData",
+                       "-cp", appJar,
+                       "-Xlog:cds+heap",
+                       "-Xlog:cds+resolve=trace",
+                       "-Xlog:cds,cds+class=debug")
+            .setArchiveName(archiveName);
+        staticDumpOutput = CDSTestUtils.createArchiveAndCheck(opts);
+        TestCommon.checkExecReturn(staticDumpOutput, 0, true);
+
+        if ((runMode & RUN_STATIC) != 0) {
+            // Run with static archive
+            System.out.println("#" + testNumber + ": Run with static archive (no AOT)");
+            CDSOptions runOpts = (new CDSOptions())
+                .addPrefix("-cp", appJar)
+                .setArchiveName(archiveName)
+                .setUseVersion(false)
+                .addSuffix(mainClass)
+                .addSuffix(productionArg);
+            if ((runMode & RUN_BENCH) != 0) {
+                runOpts.setBenchmarkMode(true);
+            } else {
+                runOpts.addPrefix("-Xlog:class+load", "-Xlog:cds=debug", "-Xlog:cds+heap=debug",
+                                  "-Xlog:methodhandles");
+            }
+            output = CDSTestUtils.runWithArchive(runOpts);
+            TestCommon.checkExecReturn(output, 0, true);
+        }
+
+        if ((runMode & RUN_AOT) != 0) {
+            System.out.println("#" + testNumber +
+                               ": (STEP 3 of 5) Run with static archive and dump profile in dynamic archive (With Training Data Replay)");
+            String dynamicArchiveName = s + "-dyn.jsa";
+            CDSOptions dynDumpOpts = (new CDSOptions())
+                .addPrefix("-cp", appJar)
+                .setArchiveName(archiveName)
+                .setUseVersion(false)
+                .addSuffix("-XX:ArchiveClassesAtExit=" + dynamicArchiveName)
+                .addSuffix("-XX:-BackgroundCompilation")
+                .addSuffix("-XX:+RecordTraining");
+            if ((runMode & RUN_BENCH) != 0) {
+                dynDumpOpts.setBenchmarkMode(true);
+                dynDumpOpts.addPrefix("-Xlog:cds=debug", "-Xlog:scc");
+            } else {
+                dynDumpOpts.addPrefix("-Xlog:class+load", "-Xlog:cds=debug",
+                                      "-Xlog:cds+class=debug");
+            }
+            // The main class name and arguments
+            dynDumpOpts
+                .addSuffix(mainClass)
+                .addSuffix(productionArg);
+            output = CDSTestUtils.runWithArchive(dynDumpOpts);
+            TestCommon.checkExecReturn(output, 0, true);
+
+            //======================================================================
+            System.out.println("#" + testNumber +
+                               ": (STEP 4 of 5) Run with dynamic archive and generate AOT code");
+            String sharedCodeArchive = s + ".scc";
+            CDSOptions aotOpts = (new CDSOptions())
+                .addPrefix("-cp", appJar)
+                .setArchiveName(archiveName)
+                .setUseVersion(false)
+                .addSuffix("-XX:-BackgroundCompilation")
+                .addSuffix("-XX:+StoreCachedCode")
+                .addSuffix("-XX:CachedCodeFile=" + sharedCodeArchive)
+                .addSuffix("-XX:CachedCodeMaxSize=100M");
+
+            if ((runMode & RUN_BENCH) != 0) {
+                aotOpts.setBenchmarkMode(true);
+                aotOpts.addPrefix("-Xlog:cds=debug", "-Xlog:scc");
+            } else {
+                aotOpts.addPrefix("-Xlog:class+load", "-Xlog:cds=debug", "-Xlog:scc+init,scc+exit");
+                if (mainClass.equals("ConcatA")) {
+                    // Hard-code the printing of loopA for now
+                    dynDumpOpts
+                        .addSuffix("-XX:CompileCommand=print,*::loopA")
+                        .addSuffix("-XX:+PrintAssembly");
+                }
+            }
+            // The main class name and arguments
+            aotOpts
+                .addSuffix(mainClass)
+                .addSuffix(productionArg);
+            output = CDSTestUtils.runWithArchive(aotOpts);
+            TestCommon.checkExecReturn(output, 0, true);
+
+            //======================================================================
+            System.out.println("#" + testNumber + ": (STEP 5 of 5) Run with dynamic archive and AOT cache");
+            CDSOptions runOpts = (new CDSOptions())
+                .addPrefix("-cp", appJar)
+                .setArchiveName(dynamicArchiveName)
+                .addSuffix("-XX:+LoadCachedCode")
+                .addSuffix("-XX:CachedCodeFile=" + sharedCodeArchive)
+                .setUseVersion(false)
+                .addSuffix(mainClass)
+                .addSuffix(productionArg);
+
+            if ((runMode & RUN_BENCH) != 0) {
+                runOpts.setBenchmarkMode(true);
+            } else {
+                // Tell CDSTestUtils to not add the -XX:VerifyArchivedFields=1 flag, which seems to be causing a crash
+                // in the AOT code.
+                runOpts.setBenchmarkMode(true);
+
+                runOpts.addPrefix("-Xlog:class+load", "-Xlog:cds=debug", "-Xlog:scc+init");
+                if (mainClass.equals("ConcatA")) {
+                    // Hard-code the printing of loopA for now
+                    dynDumpOpts
+                        .addSuffix("-XX:CompileCommand=print,*::loopA")
+                        .addSuffix("-XX:+PrintAssembly");
+                }
+            }
+
+            output = CDSTestUtils.runWithArchive(runOpts);
+            TestCommon.checkExecReturn(output, 0, true);
+        }
+    }
+
+    static void checkExec(String expectedOutput) throws Exception {
+        checkExec(expectedOutput, /* lambdaFormsMustBeArchived*/ true);
+    }
+
+    static void checkExec(String expectedOutput, boolean lambdaFormsMustBeArchived)  throws Exception {
+        if (output == null) { // test may be skipped
+            return;
+        }
+        if (expectedOutput != null) {
+            TestCommon.checkExecReturn(output, 0, true, "OUTPUT = " + expectedOutput);
+        }
+        if (lambdaFormsMustBeArchived) {
+            output.shouldMatch("LambdaForm[$]((MH)|(DMH))/0x[0-9]+ source: shared objects file");
+            output.shouldNotMatch("LambdaForm[$]MH/0x[0-9]+ source: __JVM_LookupDefineClass__");
+            output.shouldNotMatch("LambdaForm[$]DMH/0x[0-9]+ source: __JVM_LookupDefineClass__");
+        }
+    }
+
+    static void shouldMatch(String pattern) throws Exception {
+        if (output != null) { // test may be skipped
+            output.shouldMatch(pattern);
+        }
+    }
+
+    static String runModeString(int runMode) {
+        String prefix = "";
+        String s = "";
+        if ((runMode & RUN_STATIC) != 0) {
+            s += "RUN_STATIC";
+            prefix = " | ";
+        }
+        if ((runMode & RUN_AOT) != 0) {
+            s += prefix;
+            s += "RUN_AOT";
+            prefix = " | ";
+        }
+        return s;
+    }
+}
diff a/test/hotspot/jtreg/runtime/cds/appcds/indy/StringConcatStress2.java b/test/hotspot/jtreg/runtime/cds/appcds/indy/StringConcatStress2.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/indy/StringConcatStress2.java
@@ -0,0 +1,118 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+/*
+ * @test id=static
+ * @requires vm.cds.write.archived.java.heap
+ * @library /test/jdk/lib/testlibrary /test/lib
+ * @build StringConcatStress2
+ * @run driver jdk.test.lib.helpers.ClassFileInstaller -jar app.jar StringConcatStress2App
+ * @run driver StringConcatStress2 STATIC
+ */
+
+/*
+ * @test id=leyden
+ * @requires vm.cds.write.archived.java.heap
+ * @library /test/jdk/lib/testlibrary /test/lib
+ * @build StringConcatStress2
+ * @run driver jdk.test.lib.helpers.ClassFileInstaller -jar app.jar StringConcatStress2App
+ * @run driver StringConcatStress2 LEYDEN
+ */
+
+import jdk.test.lib.cds.CDSAppTester;
+import jdk.test.lib.helpers.ClassFileInstaller;
+import jdk.test.lib.process.OutputAnalyzer;
+
+public class StringConcatStress2 {
+    static final String appJar = ClassFileInstaller.getJarPath("app.jar");
+    static final String mainClass = "StringConcatStress2App";
+
+    public static void main(String[] args) throws Exception {
+        Tester t = new Tester();
+        t.run(args);
+    }
+
+    static class Tester extends CDSAppTester {
+        public Tester() {
+            super(mainClass);
+        }
+
+        @Override
+        public String classpath(RunMode runMode) {
+            return appJar;
+        }
+
+        public String[] vmArgs(RunMode runMode) {
+            return new String[] {
+                "-XX:+AOTClassLinking", // by default enables AOTInvokeDynamicLinking
+            };
+        }
+
+        @Override
+        public String[] appCommandLine(RunMode runMode) {
+            return new String[] {
+                mainClass
+            };
+        }
+
+        @Override
+        public void checkExecution(OutputAnalyzer out, RunMode runMode) {
+            if (!runMode.isStaticDump()) {
+                out.shouldContain("Result = 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1END");
+            }
+        }
+    }
+}
+
+class StringConcatStress2App {
+    public static void main(String args[]) {
+        System.out.println("Result = " + concat23String() + "END");
+    }
+
+    // Test the handling of java.lang.invoke.StringConcat.highArityThreshold (default value is 20)
+    // in java.lang.invoke.StringConcatFactory. If we have more than this number of concats, a
+    // different form of CallSite is generated by StringConcatFactory that will uses
+    // different kinds of hidden classes than usual.
+    static String concat23String() {
+        return f0 + ","+ f1 + ","+ f2 + ","+ f3 + ","+ f4 + ","+ f5 + ","+ f6 + ","+ f7 + ","+ f8 + ","+ f9 + ","
+                + f10 + ","+ f11 + ","+ f12 + ","+ f13 + ","+ f14 + ","+ f15 + ","+ f16 + ","+ f17 + ","+ f18 + ","+ f19 + ","
+                + f20 + ","+ f21 + ","+ f22;
+    }
+
+    private static String
+            f0="1", f1="1", f2="1", f3="1", f4="1", f5="1", f6="1", f7="1", f8="1", f9="1",
+            f10="1", f11="1", f12="1", f13="1", f14="1", f15="1", f16="1", f17="1", f18="1", f19="1",
+            f20="1", f21="1", f22="1", f23="1", f24="1", f25="1", f26="1", f27="1", f28="1", f29="1",
+            f30="1", f31="1", f32="1", f33="1", f34="1", f35="1", f36="1", f37="1", f38="1", f39="1",
+            f40="1", f41="1", f42="1", f43="1", f44="1", f45="1", f46="1", f47="1", f48="1", f49="1",
+            f50="1", f51="1", f52="1", f53="1", f54="1", f55="1", f56="1", f57="1", f58="1", f59="1",
+            f60="1", f61="1", f62="1", f63="1", f64="1", f65="1", f66="1", f67="1", f68="1", f69="1",
+            f70="1", f71="1", f72="1", f73="1", f74="1", f75="1", f76="1", f77="1", f78="1", f79="1",
+            f80="1", f81="1", f82="1", f83="1", f84="1", f85="1", f86="1", f87="1", f88="1", f89="1",
+            f90="1", f91="1", f92="1", f93="1", f94="1", f95="1", f96="1", f97="1", f98="1", f99="1",
+            f100="1",f101="1",f102="1",f103="1",f104="1",f105="1",f106="1",f107="1",f108="1",f109="1",
+            f110="1",f111="1",f112="1",f113="1",f114="1",f115="1",f116="1",f117="1",f118="1",f119="1",
+            f120="1",f121="1",f122="1";
+
+}
diff a/test/hotspot/jtreg/runtime/cds/appcds/leyden/CacheOnlyClassesIn.java b/test/hotspot/jtreg/runtime/cds/appcds/leyden/CacheOnlyClassesIn.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/leyden/CacheOnlyClassesIn.java
@@ -0,0 +1,152 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+// Experimental feature to allow special instrumentation code to be executed during training run:
+//
+// Example:  app.jar   -- Contains the classes for the real application.
+//                        Entry point = the "App" class
+//           test.jar  -- Instrumentation code to exercise the app or the framework. 
+//                        Entry point = the "TestDriver" class
+//
+// Training run:
+//
+//     rm app.cds
+//     java -XX:CacheDataStore=app.cds -cp app.jar:test.jar -XX:CacheOnlyClassesIn=app.jar TestDriver
+//
+// All classes in test.jar will be excluded from app.cds
+//
+// Production run:
+//
+//     java -XX:CacheDataStore=app.cds -cp app.jar:test.jar App
+//
+// TODO:
+//     Allow "-cp app.jar" to be used in production run, so test classes don't leaked into
+//     the production run.
+
+/*
+ * @test id=static
+ * @summary test the -XX:CacheOnlyClassesIn flag with the classic static archive workflow
+ * @requires vm.cds
+ * @library /test/lib
+ * @run driver CacheOnlyClassesIn STATIC
+ */
+
+/*
+ * @test id=dynamic
+ * @summary test the -XX:CacheOnlyClassesIn flag with the classic dynamic archive workflow
+ * @requires vm.cds
+ * @library /test/lib
+ * @run driver CacheOnlyClassesIn DYNAMIC
+ */
+
+/*
+ * @test id=leyden
+ * @summary test the -XX:CacheOnlyClassesIn flag with Leyden workflow
+ * @requires vm.cds
+ * @requires vm.cds.write.archived.java.heap
+ * @library /test/lib
+ * @run driver CacheOnlyClassesIn LEYDEN
+ */
+
+import java.io.File;
+import jdk.test.lib.cds.CDSAppTester;
+import jdk.test.lib.helpers.ClassFileInstaller;
+import jdk.test.lib.process.OutputAnalyzer;
+
+public class CacheOnlyClassesIn {
+    static String mainClass = CacheOnlyClassesInApp.class.getName();
+    static String appJar, testJar;
+
+    public static void main(String args[]) throws Exception {
+        appJar = ClassFileInstaller.writeJar("app.jar",
+                                             "CacheOnlyClassesInApp");
+        testJar = ClassFileInstaller.writeJar("test.jar",
+                                             "TestHarness");
+        MyTester tester = new MyTester();
+        tester.run(args);
+    }
+
+    static class MyTester extends CDSAppTester {
+        public MyTester() {
+            super("CacheOnlyClassesInApp");
+        }
+
+        @Override
+        public String classpath(RunMode runMode) {
+            return appJar + File.pathSeparator + testJar;
+        }
+
+        @Override
+        public String[] vmArgs(RunMode runMode) {
+            return new String[] {
+                "-XX:CacheOnlyClassesIn=" + appJar,
+            };
+        }
+
+        @Override
+        public String[] appCommandLine(RunMode runMode) {
+            return new String[] {
+                mainClass,
+            };
+        }
+
+        @Override
+        public void checkExecution(OutputAnalyzer out, RunMode runMode) throws Exception {
+            if (runMode == RunMode.DUMP_STATIC ||
+                runMode == RunMode.DUMP_DYNAMIC ||
+                runMode == RunMode.TRAINING ||
+                runMode == RunMode.TRAINING0) {
+                out.shouldContain("Skipping TestHarness: excluded via -XX:CacheOnlyClassesIn");
+            }
+        }
+    }
+}
+
+class CacheOnlyClassesInApp {
+    public static void main(String args[]) {
+        System.out.println("Hello World = " + TestHarness.doit());
+    }
+
+    static volatile int x;
+    public static int testLoop() {
+        for (int i = 0; i < 100000000; i++) {
+            x ^= (x + 39);
+        }
+        return x;
+    }
+}
+
+class TestHarness {
+    static int doit() {
+        return CacheOnlyClassesInApp.testLoop() + myTestLoop();
+    }
+
+    static volatile int x;
+    public static int myTestLoop() {
+        for (int i = 0; i < 100000000; i++) {
+            x ^= (x + 39);
+        }
+        return x;
+    }
+}
